.nolist
include \masm32\include\masm32rt.inc
include \masm32\macros\timers.asm

.686
.xmm

markl_CountFileLines	PROTO: DWORD
CompteurLignes		PROTO: DWORD, :DWORD

	LOOP_COUNT = 5000

.data?
cbFile	dd ?
hFile	dd ?
Win$	dd ?
bytesread	dd ?

.data
wininc	db "\masm32\include\windows.inc", 0

.code

start:
	mov Win$, alloc$(1000000)
	print "Counting lines of "
	print offset wininc, ":", 13, 10, 10
	mov hFile, fopen(offset wininc)
	mov cbFile, fsize(eax)
	invoke ReadFile, hFile, Win$, cbFile, offset bytesread, 0
	fclose hFile
	print "markl_CountFileLines:", 13, 10
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		invoke markl_CountFileLines, Win$
		mov esi, eax
	counter_end
	print str$(eax), 9, "cycles for "	; 33000 cycles on P4, 49000 unaligned; 5000 for 16k... a factor 5???
	print str$(esi), " lines, "
	print str$(cbFile), " bytes", 13, 10, 10

	print "CompteurLignes:", 13, 10
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		invoke CompteurLignes, Win$, cbFile
		mov esi, eax
	counter_end
	print str$(eax), 9, "cycles for "	; 33000 cycles on P4, 49000 unaligned; 5000 for 16k... a factor 5???
	print str$(esi), " lines, "
	print str$(cbFile), " bytes", 13, 10, 10
	inkey "Hit any key"
	exit

OPTION PROLOGUE:none
OPTION EPILOGUE:none
markl_CountFileLines proc src:DWORD	; [url=http://www.masm32.com/board/index.php?topic=5434.msg40666#msg40666]Mark Larson[/url]
  mov eax,0a0a0a0ah

  movd xmm7,eax
  mov edx, [esp+4]	; Win$	; offset [pFilebuffer]
  pshufd xmm7,xmm7,00000000b
  mov ecx, [cbFile]

  pxor xmm6, xmm6

  shr ecx,11 ;divide by 128*16
  jnc evenly_divisible
  inc ecx
evenly_divisible:

@@:
  pxor xmm5, xmm5
  ;i think it is the unrolling that is hosing things.
  i = 0
  WHILE i LT (16*128)
	movdqu xmm0, [edx + i +  0]
	movdqu xmm1, [edx + i + 16]
	movdqu xmm2, [edx + i + 32]
	movdqu xmm3, [edx + i + 48]

	pcmpeqb xmm0, xmm7
	pcmpeqb xmm1, xmm7
	pcmpeqb xmm2, xmm7
	pcmpeqb xmm3, xmm7

	paddb xmm0, xmm1
	paddb xmm2, xmm3

	paddb xmm0, xmm2

	; can't you do this step outside the loop?  I am pretty sure you can.
	psubb xmm5, xmm0 ; total 128*8 max = 1K
	i=i+16*4
  ENDM

; unpack MM5 to get sum in 1K block
pxor xmm0, xmm0
psadbw xmm5, xmm0
paddd xmm6, xmm5

dec ecx
lea edx, [edx + 128*16]
jne @B

movd eax, xmm6
psrldq xmm6,8 ;shift Right 8 bytes
movd ebx, xmm6
add eax, ebx
ret 4
markl_CountFileLines ENDP

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

CompteurLignes PROC uses ebx edi esi pmem:DWORD,taille:DWORD
			local  theEnd:dword,retenue:DWORD
			Local  retour:DWORD
.data
	sse2entree 	db 13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,0 
	sse2line	db 10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,0
.code
	;init of various register
	mov retenue,0
	lea eax,sse2entree
	movups xmm6,[eax]
	lea eax,sse2line
	movups xmm7,[eax]
	mov eax,pmem
	add eax,taille
	mov theEnd,eax
	mov edx,pmem
	mov eax,0	;line counter
	;ready
	NewBloc:
	mov edx,pmem
	movups xmm1,[edx]			;load 16 bytes
	movups xmm2,[edx]			;charger les mmes 16 bytes
	pcmpeqb  xmm1,xmm6		;13 ,xmm1 modified
	;ff 00 ff 00 ff 00 ff 00-00 00 00 00 00 00 00 00  ;example of modified xmm1 in the dugger
	pcmpeqb  xmm2,xmm7		;10 ,xmm2 modified	
	;00 ff 00 ff 00 ff 00 ff-00 00 00 00 00 00 00 00  ;modified xmm2
	;--------- debug ---------
	;lea edx,TamponVisu1		;just here to view the result in the debugger
	;movups [edx],xmm1
	;lea edx,TamponVisu2	
	;movups [edx],xmm2		
	;-------- debug ------------------
	;the ;ff 00 ff .... must be read right to left
	;ecx and edx must be read left to right
	pmovmskb ecx, xmm1 ;1010101	;result for 13 in ecx  
	pmovmskb edx, xmm2 ;10101010	;result for 10 in edx
	;each 13 are now only  a  bit in ecx
	;each 10 are now only a bit in edx 
	;---------- search for bits and there positions -------
	;instructions are internal and very fast
	;ecx and edx have now her bits set to 1 as the same position 
	
	.if retenue == 1
		;the last 16 bytes loaded was ended by a 13,bit 15
		;Test if bit zero is one (there is a 10)
		bsf  edi,edx		;search the 10
		.if edi == 0 && edx != 0	
			btr edx,edi			;delet the bit find in edx,10
			inc eax			;inc the number of lines
		.endif				
	.endif
	NewEntree:
	bsf	ebx,ecx			;give the position of one bit at 1
	.if ebx == 0 && ecx != 0
		;le bit zero est a 1
		jmp bitzero13a1
	.endif
	.if ebx				;not zero ,on a un 13			
		bitzero13a1:
		btr ecx,ebx			;efface le bit trouv dans ecx
		.if ebx != 15
			inc ebx		      ;incrmente sa positon pour la comparer au 10
		.elseif
			mov retenue,1	;le 10 va se trouver dans le chargement suivant
			jmp NewSeriede16
			;suite a voir
		.endif
		
		traiteretenue:
		bsf  edi,edx		;cherche le 0A
		.if edi == 0 && edx != 0
			;le bit zero des 10 est a 1
			jmp bitzero10a1
		.endif
		.if  edi
			bitzero10a1:
			btr edx,edi			;efface le bit trouv dans edx,10			
			.if ebx == edi	;un 10 suit immdiatement le 13		
				inc eax	;////////// inc the number of lines /////////////////
			.elseif ebx >edi
				;this 10 is alone
				;c'est un 10 isol avant le 13 ,HTML
				mov edi,0
				jmp traiteretenue 
			.endif
		.endif
		;------ conditions de rebouclage ---------------
		.if ecx != 0
			mov ebx,0		;avoid an undeterminated state
			mov edi,0
			jmp NewEntree
		.endif
	.endif
	NewSeriede16:
	mov edx,pmem
	add edx,16	
	mov pmem,edx
	.if edx < theEnd
		jmp NewBloc
	.endif

 FindeCompteurLignes:
         ret
CompteurLignes endp

end start
OxPT_Linker	polink	; delete the red x if you want to use Pelle's linker
OPT_WAIT	0	; 1=wait until a key is pressed before closing the DOS box
OPT_Assembler	ml
OPT_DelTmp	0
OPT_Tmp2Asm	1
